#!/usr/bin/env bash
set -e
set -u
set -o pipefail

domain="${2}"
token_id="${3}"
token="${4}"

case "${1}" in
    "deploy_challenge")
        statuscode="$(curl -s -k -n -L -o /dev/null -w "%{http_code}" "https://${domain}/.well-known/acme-challenge/manage_addFile?id=${token_id}")"
        if [[ ! "${statuscode:0:1}" = "2" ]]; then
            statuscode="$(curl -s -n -L -o /dev/null -w "%{http_code}" "http://${domain}/.well-known/acme-challenge/manage_addFile?id=${token_id}")"
            if [[ ! "${statuscode:0:1}" = "2" ]]; then
                echo 'Failed'
                exit 1
            fi
        fi
        statuscode="$(curl -s -k -n -L -o /dev/null -w "%{http_code}" "https://${domain}/.well-known/acme-challenge/${token_id}/manage_edit?title=&content_type=text/plain&filedata=${token}")"
        if [[ ! "${statuscode:0:1}" = "2" ]]; then
            statuscode="$(curl -s -n -L -o /dev/null -w "%{http_code}" "http://${domain}/.well-known/acme-challenge/${token_id}/manage_edit?title=&content_type=text/plain&filedata=${token}")"
            if [[ ! "${statuscode:0:1}" = "2" ]]; then
                echo 'Failed'
                exit 1
            fi
        fi
    ;;
    "clean_challenge")
        statuscode="$(curl -s -k -n -L -o /dev/null -w "%{http_code}" "https://${domain}/.well-known/acme-challenge/manage_delObjects?ids:list=${token_id}")"
        if [[ ! "${statuscode:0:1}" = "2" ]]; then
            statuscode="$(curl -s -n -L -o /dev/null -w "%{http_code}" "http://${domain}/.well-known/acme-challenge/manage_delObjects?ids:list=${token_id}")"
            if [[ ! "${statuscode:0:1}" = "2" ]]; then
                echo 'Failed'
                exit 1
            fi
        fi
    ;;
esac

exit 0
